"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BlockCommunityResponse = exports.BlockCommunity = exports.TransferCommunity = exports.FollowCommunity = exports.RemoveCommunity = exports.DeleteCommunity = exports.EditCommunity = exports.AddModToCommunityResponse = exports.AddModToCommunity = exports.BanFromCommunityResponse = exports.BanFromCommunity = exports.ListCommunitiesResponse = exports.ListCommunities = exports.CommunityResponse = exports.CreateCommunity = exports.GetCommunityResponse = exports.GetCommunity = void 0;
var class_transformer_1 = require("class-transformer");
require("reflect-metadata");
var utils_1 = require("../../utils");
var source_1 = require("../source");
var views_1 = require("../views");
/**
 * You can use either `id` or `name` as an id.
 *
 * To get a federated community by name, use `name@instance.tld` .
 */
var GetCommunity = /** @class */ (function () {
    function GetCommunity(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetCommunity.prototype, "id", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetCommunity.prototype, "name", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetCommunity.prototype, "auth", void 0);
    return GetCommunity;
}());
exports.GetCommunity = GetCommunity;
var GetCommunityResponse = /** @class */ (function () {
    function GetCommunityResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.CommunityView; })
    ], GetCommunityResponse.prototype, "community_view", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return source_1.Site; })
    ], GetCommunityResponse.prototype, "site", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.CommunityModeratorView; })
    ], GetCommunityResponse.prototype, "moderators", void 0);
    return GetCommunityResponse;
}());
exports.GetCommunityResponse = GetCommunityResponse;
var CreateCommunity = /** @class */ (function () {
    function CreateCommunity(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreateCommunity.prototype, "description", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreateCommunity.prototype, "icon", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreateCommunity.prototype, "banner", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreateCommunity.prototype, "nsfw", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreateCommunity.prototype, "posting_restricted_to_mods", void 0);
    return CreateCommunity;
}());
exports.CreateCommunity = CreateCommunity;
var CommunityResponse = /** @class */ (function () {
    function CommunityResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.CommunityView; })
    ], CommunityResponse.prototype, "community_view", void 0);
    return CommunityResponse;
}());
exports.CommunityResponse = CommunityResponse;
var ListCommunities = /** @class */ (function () {
    function ListCommunities(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], ListCommunities.prototype, "type_", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], ListCommunities.prototype, "sort", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], ListCommunities.prototype, "page", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], ListCommunities.prototype, "limit", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], ListCommunities.prototype, "auth", void 0);
    return ListCommunities;
}());
exports.ListCommunities = ListCommunities;
var ListCommunitiesResponse = /** @class */ (function () {
    function ListCommunitiesResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.CommunityView; })
    ], ListCommunitiesResponse.prototype, "communities", void 0);
    return ListCommunitiesResponse;
}());
exports.ListCommunitiesResponse = ListCommunitiesResponse;
var BanFromCommunity = /** @class */ (function () {
    function BanFromCommunity(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], BanFromCommunity.prototype, "remove_data", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], BanFromCommunity.prototype, "reason", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], BanFromCommunity.prototype, "expires", void 0);
    return BanFromCommunity;
}());
exports.BanFromCommunity = BanFromCommunity;
var BanFromCommunityResponse = /** @class */ (function () {
    function BanFromCommunityResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.PersonViewSafe; })
    ], BanFromCommunityResponse.prototype, "person_view", void 0);
    return BanFromCommunityResponse;
}());
exports.BanFromCommunityResponse = BanFromCommunityResponse;
var AddModToCommunity = /** @class */ (function () {
    function AddModToCommunity(init) {
        Object.assign(this, init);
    }
    return AddModToCommunity;
}());
exports.AddModToCommunity = AddModToCommunity;
var AddModToCommunityResponse = /** @class */ (function () {
    function AddModToCommunityResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.CommunityModeratorView; })
    ], AddModToCommunityResponse.prototype, "moderators", void 0);
    return AddModToCommunityResponse;
}());
exports.AddModToCommunityResponse = AddModToCommunityResponse;
/**
 * Only mods can edit a community.
 */
var EditCommunity = /** @class */ (function () {
    function EditCommunity(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditCommunity.prototype, "title", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditCommunity.prototype, "description", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditCommunity.prototype, "icon", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditCommunity.prototype, "banner", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditCommunity.prototype, "nsfw", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditCommunity.prototype, "posting_restricted_to_mods", void 0);
    return EditCommunity;
}());
exports.EditCommunity = EditCommunity;
var DeleteCommunity = /** @class */ (function () {
    function DeleteCommunity(init) {
        Object.assign(this, init);
    }
    return DeleteCommunity;
}());
exports.DeleteCommunity = DeleteCommunity;
/**
 * Only admins can remove a community.
 */
var RemoveCommunity = /** @class */ (function () {
    function RemoveCommunity(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], RemoveCommunity.prototype, "reason", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], RemoveCommunity.prototype, "expires", void 0);
    return RemoveCommunity;
}());
exports.RemoveCommunity = RemoveCommunity;
var FollowCommunity = /** @class */ (function () {
    function FollowCommunity(init) {
        Object.assign(this, init);
    }
    return FollowCommunity;
}());
exports.FollowCommunity = FollowCommunity;
var TransferCommunity = /** @class */ (function () {
    function TransferCommunity(init) {
        Object.assign(this, init);
    }
    return TransferCommunity;
}());
exports.TransferCommunity = TransferCommunity;
var BlockCommunity = /** @class */ (function () {
    function BlockCommunity(init) {
        Object.assign(this, init);
    }
    return BlockCommunity;
}());
exports.BlockCommunity = BlockCommunity;
var BlockCommunityResponse = /** @class */ (function () {
    function BlockCommunityResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.CommunityView; })
    ], BlockCommunityResponse.prototype, "community_view", void 0);
    return BlockCommunityResponse;
}());
exports.BlockCommunityResponse = BlockCommunityResponse;
