"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BannedPersonsResponse = exports.GetBannedPersons = exports.BlockPersonResponse = exports.BlockPerson = exports.VerifyEmailResponse = exports.VerifyEmail = exports.GetUnreadCountResponse = exports.GetUnreadCount = exports.GetReportCountResponse = exports.GetReportCount = exports.PrivateMessageResponse = exports.PrivateMessagesResponse = exports.GetPrivateMessages = exports.MarkPrivateMessageAsRead = exports.DeletePrivateMessage = exports.EditPrivateMessage = exports.CreatePrivateMessage = exports.PasswordChange = exports.PasswordResetResponse = exports.PasswordReset = exports.DeleteAccountResponse = exports.DeleteAccount = exports.CommentReplyResponse = exports.MarkCommentReplyAsRead = exports.PersonMentionResponse = exports.MarkPersonMentionAsRead = exports.GetPersonMentions = exports.GetReplies = exports.BanPersonResponse = exports.BanPerson = exports.AddAdminResponse = exports.AddAdmin = exports.MarkAllAsRead = exports.GetPersonMentionsResponse = exports.GetRepliesResponse = exports.GetPersonDetailsResponse = exports.GetPersonDetails = exports.LoginResponse = exports.ChangePassword = exports.SaveUserSettings = exports.CaptchaResponse = exports.GetCaptchaResponse = exports.GetCaptcha = exports.Register = exports.Login = void 0;
var class_transformer_1 = require("class-transformer");
require("reflect-metadata");
var utils_1 = require("../../utils");
var views_1 = require("../views");
var Login = /** @class */ (function () {
    function Login(init) {
        Object.assign(this, init);
    }
    return Login;
}());
exports.Login = Login;
/**
 * Register a new user.
 *
 * Only the first user to register will be able to be the admin.
 */
var Register = /** @class */ (function () {
    function Register(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], Register.prototype, "email", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], Register.prototype, "captcha_uuid", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], Register.prototype, "captcha_answer", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], Register.prototype, "honeypot", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], Register.prototype, "answer", void 0);
    return Register;
}());
exports.Register = Register;
var GetCaptcha = /** @class */ (function () {
    function GetCaptcha() {
    }
    return GetCaptcha;
}());
exports.GetCaptcha = GetCaptcha;
var GetCaptchaResponse = /** @class */ (function () {
    function GetCaptchaResponse() {
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return CaptchaResponse; })
    ], GetCaptchaResponse.prototype, "ok", void 0);
    return GetCaptchaResponse;
}());
exports.GetCaptchaResponse = GetCaptchaResponse;
var CaptchaResponse = /** @class */ (function () {
    function CaptchaResponse() {
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CaptchaResponse.prototype, "wav", void 0);
    return CaptchaResponse;
}());
exports.CaptchaResponse = CaptchaResponse;
var SaveUserSettings = /** @class */ (function () {
    function SaveUserSettings(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], SaveUserSettings.prototype, "show_nsfw", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], SaveUserSettings.prototype, "theme", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], SaveUserSettings.prototype, "default_sort_type", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], SaveUserSettings.prototype, "default_listing_type", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], SaveUserSettings.prototype, "lang", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], SaveUserSettings.prototype, "avatar", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], SaveUserSettings.prototype, "banner", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], SaveUserSettings.prototype, "display_name", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], SaveUserSettings.prototype, "email", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], SaveUserSettings.prototype, "bio", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], SaveUserSettings.prototype, "matrix_user_id", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], SaveUserSettings.prototype, "show_avatars", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], SaveUserSettings.prototype, "show_scores", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], SaveUserSettings.prototype, "send_notifications_to_email", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], SaveUserSettings.prototype, "bot_account", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], SaveUserSettings.prototype, "show_bot_accounts", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], SaveUserSettings.prototype, "show_read_posts", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], SaveUserSettings.prototype, "show_new_post_notifs", void 0);
    return SaveUserSettings;
}());
exports.SaveUserSettings = SaveUserSettings;
var ChangePassword = /** @class */ (function () {
    function ChangePassword(init) {
        Object.assign(this, init);
    }
    return ChangePassword;
}());
exports.ChangePassword = ChangePassword;
/**
 * The `jwt` string should be stored and used anywhere `auth` is called for.
 */
var LoginResponse = /** @class */ (function () {
    function LoginResponse() {
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], LoginResponse.prototype, "jwt", void 0);
    return LoginResponse;
}());
exports.LoginResponse = LoginResponse;
var GetPersonDetails = /** @class */ (function () {
    function GetPersonDetails(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPersonDetails.prototype, "person_id", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPersonDetails.prototype, "username", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPersonDetails.prototype, "sort", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPersonDetails.prototype, "page", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPersonDetails.prototype, "limit", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPersonDetails.prototype, "community_id", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPersonDetails.prototype, "saved_only", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPersonDetails.prototype, "auth", void 0);
    return GetPersonDetails;
}());
exports.GetPersonDetails = GetPersonDetails;
var GetPersonDetailsResponse = /** @class */ (function () {
    function GetPersonDetailsResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.PersonViewSafe; })
    ], GetPersonDetailsResponse.prototype, "person_view", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.CommentView; })
    ], GetPersonDetailsResponse.prototype, "comments", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.PostView; })
    ], GetPersonDetailsResponse.prototype, "posts", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.CommunityModeratorView; })
    ], GetPersonDetailsResponse.prototype, "moderates", void 0);
    return GetPersonDetailsResponse;
}());
exports.GetPersonDetailsResponse = GetPersonDetailsResponse;
var GetRepliesResponse = /** @class */ (function () {
    function GetRepliesResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.CommentReplyView; })
    ], GetRepliesResponse.prototype, "replies", void 0);
    return GetRepliesResponse;
}());
exports.GetRepliesResponse = GetRepliesResponse;
var GetPersonMentionsResponse = /** @class */ (function () {
    function GetPersonMentionsResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.PersonMentionView; })
    ], GetPersonMentionsResponse.prototype, "mentions", void 0);
    return GetPersonMentionsResponse;
}());
exports.GetPersonMentionsResponse = GetPersonMentionsResponse;
var MarkAllAsRead = /** @class */ (function () {
    function MarkAllAsRead(auth) {
        this.auth = auth;
    }
    return MarkAllAsRead;
}());
exports.MarkAllAsRead = MarkAllAsRead;
var AddAdmin = /** @class */ (function () {
    function AddAdmin(init) {
        Object.assign(this, init);
    }
    return AddAdmin;
}());
exports.AddAdmin = AddAdmin;
var AddAdminResponse = /** @class */ (function () {
    function AddAdminResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.PersonViewSafe; })
    ], AddAdminResponse.prototype, "admins", void 0);
    return AddAdminResponse;
}());
exports.AddAdminResponse = AddAdminResponse;
var BanPerson = /** @class */ (function () {
    function BanPerson(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], BanPerson.prototype, "remove_data", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], BanPerson.prototype, "reason", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], BanPerson.prototype, "expires", void 0);
    return BanPerson;
}());
exports.BanPerson = BanPerson;
var BanPersonResponse = /** @class */ (function () {
    function BanPersonResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.PersonViewSafe; })
    ], BanPersonResponse.prototype, "person_view", void 0);
    return BanPersonResponse;
}());
exports.BanPersonResponse = BanPersonResponse;
var GetReplies = /** @class */ (function () {
    function GetReplies(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetReplies.prototype, "sort", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetReplies.prototype, "page", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetReplies.prototype, "limit", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetReplies.prototype, "unread_only", void 0);
    return GetReplies;
}());
exports.GetReplies = GetReplies;
var GetPersonMentions = /** @class */ (function () {
    function GetPersonMentions(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPersonMentions.prototype, "sort", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPersonMentions.prototype, "page", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPersonMentions.prototype, "limit", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPersonMentions.prototype, "unread_only", void 0);
    return GetPersonMentions;
}());
exports.GetPersonMentions = GetPersonMentions;
var MarkPersonMentionAsRead = /** @class */ (function () {
    function MarkPersonMentionAsRead(init) {
        Object.assign(this, init);
    }
    return MarkPersonMentionAsRead;
}());
exports.MarkPersonMentionAsRead = MarkPersonMentionAsRead;
var PersonMentionResponse = /** @class */ (function () {
    function PersonMentionResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.PersonMentionView; })
    ], PersonMentionResponse.prototype, "person_mention_view", void 0);
    return PersonMentionResponse;
}());
exports.PersonMentionResponse = PersonMentionResponse;
var MarkCommentReplyAsRead = /** @class */ (function () {
    function MarkCommentReplyAsRead(init) {
        Object.assign(this, init);
    }
    return MarkCommentReplyAsRead;
}());
exports.MarkCommentReplyAsRead = MarkCommentReplyAsRead;
var CommentReplyResponse = /** @class */ (function () {
    function CommentReplyResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.CommentReplyView; })
    ], CommentReplyResponse.prototype, "comment_reply_view", void 0);
    return CommentReplyResponse;
}());
exports.CommentReplyResponse = CommentReplyResponse;
/**
 * Permanently deletes your posts and comments
 */
var DeleteAccount = /** @class */ (function () {
    function DeleteAccount(init) {
        Object.assign(this, init);
    }
    return DeleteAccount;
}());
exports.DeleteAccount = DeleteAccount;
var DeleteAccountResponse = /** @class */ (function () {
    function DeleteAccountResponse() {
    }
    return DeleteAccountResponse;
}());
exports.DeleteAccountResponse = DeleteAccountResponse;
var PasswordReset = /** @class */ (function () {
    function PasswordReset(init) {
        Object.assign(this, init);
    }
    return PasswordReset;
}());
exports.PasswordReset = PasswordReset;
var PasswordResetResponse = /** @class */ (function () {
    function PasswordResetResponse() {
    }
    return PasswordResetResponse;
}());
exports.PasswordResetResponse = PasswordResetResponse;
var PasswordChange = /** @class */ (function () {
    function PasswordChange(init) {
        Object.assign(this, init);
    }
    return PasswordChange;
}());
exports.PasswordChange = PasswordChange;
var CreatePrivateMessage = /** @class */ (function () {
    function CreatePrivateMessage(init) {
        Object.assign(this, init);
    }
    return CreatePrivateMessage;
}());
exports.CreatePrivateMessage = CreatePrivateMessage;
var EditPrivateMessage = /** @class */ (function () {
    function EditPrivateMessage(init) {
        Object.assign(this, init);
    }
    return EditPrivateMessage;
}());
exports.EditPrivateMessage = EditPrivateMessage;
var DeletePrivateMessage = /** @class */ (function () {
    function DeletePrivateMessage(init) {
        Object.assign(this, init);
    }
    return DeletePrivateMessage;
}());
exports.DeletePrivateMessage = DeletePrivateMessage;
var MarkPrivateMessageAsRead = /** @class */ (function () {
    function MarkPrivateMessageAsRead(init) {
        Object.assign(this, init);
    }
    return MarkPrivateMessageAsRead;
}());
exports.MarkPrivateMessageAsRead = MarkPrivateMessageAsRead;
var GetPrivateMessages = /** @class */ (function () {
    function GetPrivateMessages(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPrivateMessages.prototype, "unread_only", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPrivateMessages.prototype, "page", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPrivateMessages.prototype, "limit", void 0);
    return GetPrivateMessages;
}());
exports.GetPrivateMessages = GetPrivateMessages;
var PrivateMessagesResponse = /** @class */ (function () {
    function PrivateMessagesResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.PrivateMessageView; })
    ], PrivateMessagesResponse.prototype, "private_messages", void 0);
    return PrivateMessagesResponse;
}());
exports.PrivateMessagesResponse = PrivateMessagesResponse;
var PrivateMessageResponse = /** @class */ (function () {
    function PrivateMessageResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.PrivateMessageView; })
    ], PrivateMessageResponse.prototype, "private_message_view", void 0);
    return PrivateMessageResponse;
}());
exports.PrivateMessageResponse = PrivateMessageResponse;
var GetReportCount = /** @class */ (function () {
    function GetReportCount(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetReportCount.prototype, "community_id", void 0);
    return GetReportCount;
}());
exports.GetReportCount = GetReportCount;
var GetReportCountResponse = /** @class */ (function () {
    function GetReportCountResponse() {
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetReportCountResponse.prototype, "community_id", void 0);
    return GetReportCountResponse;
}());
exports.GetReportCountResponse = GetReportCountResponse;
var GetUnreadCount = /** @class */ (function () {
    function GetUnreadCount(init) {
        Object.assign(this, init);
    }
    return GetUnreadCount;
}());
exports.GetUnreadCount = GetUnreadCount;
var GetUnreadCountResponse = /** @class */ (function () {
    function GetUnreadCountResponse() {
    }
    return GetUnreadCountResponse;
}());
exports.GetUnreadCountResponse = GetUnreadCountResponse;
var VerifyEmail = /** @class */ (function () {
    function VerifyEmail(init) {
        Object.assign(this, init);
    }
    return VerifyEmail;
}());
exports.VerifyEmail = VerifyEmail;
var VerifyEmailResponse = /** @class */ (function () {
    function VerifyEmailResponse() {
    }
    return VerifyEmailResponse;
}());
exports.VerifyEmailResponse = VerifyEmailResponse;
var BlockPerson = /** @class */ (function () {
    function BlockPerson(init) {
        Object.assign(this, init);
    }
    return BlockPerson;
}());
exports.BlockPerson = BlockPerson;
var BlockPersonResponse = /** @class */ (function () {
    function BlockPersonResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.PersonViewSafe; })
    ], BlockPersonResponse.prototype, "person_view", void 0);
    return BlockPersonResponse;
}());
exports.BlockPersonResponse = BlockPersonResponse;
var GetBannedPersons = /** @class */ (function () {
    function GetBannedPersons(init) {
        Object.assign(this, init);
    }
    return GetBannedPersons;
}());
exports.GetBannedPersons = GetBannedPersons;
var BannedPersonsResponse = /** @class */ (function () {
    function BannedPersonsResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.PersonViewSafe; })
    ], BannedPersonsResponse.prototype, "banned", void 0);
    return BannedPersonsResponse;
}());
exports.BannedPersonsResponse = BannedPersonsResponse;
