"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetSiteMetadataResponse = exports.GetSiteMetadata = exports.ListPostReportsResponse = exports.ListPostReports = exports.ResolvePostReport = exports.PostReportResponse = exports.CreatePostReport = exports.SavePost = exports.StickyPost = exports.LockPost = exports.MarkPostAsRead = exports.RemovePost = exports.DeletePost = exports.EditPost = exports.CreatePostLike = exports.GetPostsResponse = exports.GetPosts = exports.GetPostResponse = exports.GetPost = exports.PostResponse = exports.CreatePost = void 0;
var class_transformer_1 = require("class-transformer");
require("reflect-metadata");
var utils_1 = require("../../utils");
var others_1 = require("../others");
var views_1 = require("../views");
var CreatePost = /** @class */ (function () {
    function CreatePost(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreatePost.prototype, "url", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreatePost.prototype, "body", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreatePost.prototype, "nsfw", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreatePost.prototype, "honeypot", void 0);
    return CreatePost;
}());
exports.CreatePost = CreatePost;
var PostResponse = /** @class */ (function () {
    function PostResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.PostView; })
    ], PostResponse.prototype, "post_view", void 0);
    return PostResponse;
}());
exports.PostResponse = PostResponse;
var GetPost = /** @class */ (function () {
    function GetPost(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPost.prototype, "id", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPost.prototype, "comment_id", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPost.prototype, "auth", void 0);
    return GetPost;
}());
exports.GetPost = GetPost;
var GetPostResponse = /** @class */ (function () {
    function GetPostResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.PostView; })
    ], GetPostResponse.prototype, "post_view", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.CommunityView; })
    ], GetPostResponse.prototype, "community_view", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.CommunityModeratorView; })
    ], GetPostResponse.prototype, "moderators", void 0);
    return GetPostResponse;
}());
exports.GetPostResponse = GetPostResponse;
var GetPosts = /** @class */ (function () {
    function GetPosts(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPosts.prototype, "type_", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPosts.prototype, "sort", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPosts.prototype, "page", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPosts.prototype, "limit", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPosts.prototype, "community_id", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPosts.prototype, "community_name", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPosts.prototype, "saved_only", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetPosts.prototype, "auth", void 0);
    return GetPosts;
}());
exports.GetPosts = GetPosts;
var GetPostsResponse = /** @class */ (function () {
    function GetPostsResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.PostView; })
    ], GetPostsResponse.prototype, "posts", void 0);
    return GetPostsResponse;
}());
exports.GetPostsResponse = GetPostsResponse;
var CreatePostLike = /** @class */ (function () {
    function CreatePostLike(init) {
        Object.assign(this, init);
    }
    return CreatePostLike;
}());
exports.CreatePostLike = CreatePostLike;
var EditPost = /** @class */ (function () {
    function EditPost(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditPost.prototype, "name", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditPost.prototype, "url", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditPost.prototype, "body", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditPost.prototype, "nsfw", void 0);
    return EditPost;
}());
exports.EditPost = EditPost;
var DeletePost = /** @class */ (function () {
    function DeletePost(init) {
        Object.assign(this, init);
    }
    return DeletePost;
}());
exports.DeletePost = DeletePost;
/**
 * Only admins and mods can remove a post.
 */
var RemovePost = /** @class */ (function () {
    function RemovePost(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], RemovePost.prototype, "reason", void 0);
    return RemovePost;
}());
exports.RemovePost = RemovePost;
/**
 * Marks a post as read.
 */
var MarkPostAsRead = /** @class */ (function () {
    function MarkPostAsRead(init) {
        Object.assign(this, init);
    }
    return MarkPostAsRead;
}());
exports.MarkPostAsRead = MarkPostAsRead;
/**
 * Only admins and mods can lock a post.
 */
var LockPost = /** @class */ (function () {
    function LockPost(init) {
        Object.assign(this, init);
    }
    return LockPost;
}());
exports.LockPost = LockPost;
/**
 * Only admins and mods can sticky a post.
 */
var StickyPost = /** @class */ (function () {
    function StickyPost(init) {
        Object.assign(this, init);
    }
    return StickyPost;
}());
exports.StickyPost = StickyPost;
var SavePost = /** @class */ (function () {
    function SavePost(init) {
        Object.assign(this, init);
    }
    return SavePost;
}());
exports.SavePost = SavePost;
var CreatePostReport = /** @class */ (function () {
    function CreatePostReport(init) {
        Object.assign(this, init);
    }
    return CreatePostReport;
}());
exports.CreatePostReport = CreatePostReport;
var PostReportResponse = /** @class */ (function () {
    function PostReportResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.PostReportView; })
    ], PostReportResponse.prototype, "post_report_view", void 0);
    return PostReportResponse;
}());
exports.PostReportResponse = PostReportResponse;
var ResolvePostReport = /** @class */ (function () {
    function ResolvePostReport(init) {
        Object.assign(this, init);
    }
    return ResolvePostReport;
}());
exports.ResolvePostReport = ResolvePostReport;
var ListPostReports = /** @class */ (function () {
    function ListPostReports(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], ListPostReports.prototype, "page", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], ListPostReports.prototype, "limit", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], ListPostReports.prototype, "community_id", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], ListPostReports.prototype, "unresolved_only", void 0);
    return ListPostReports;
}());
exports.ListPostReports = ListPostReports;
var ListPostReportsResponse = /** @class */ (function () {
    function ListPostReportsResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.PostReportView; })
    ], ListPostReportsResponse.prototype, "post_reports", void 0);
    return ListPostReportsResponse;
}());
exports.ListPostReportsResponse = ListPostReportsResponse;
var GetSiteMetadata = /** @class */ (function () {
    function GetSiteMetadata(init) {
        Object.assign(this, init);
    }
    return GetSiteMetadata;
}());
exports.GetSiteMetadata = GetSiteMetadata;
var GetSiteMetadataResponse = /** @class */ (function () {
    function GetSiteMetadataResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return others_1.SiteMetadata; })
    ], GetSiteMetadataResponse.prototype, "metadata", void 0);
    return GetSiteMetadataResponse;
}());
exports.GetSiteMetadataResponse = GetSiteMetadataResponse;
