"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetUnreadRegistrationApplicationCountResponse = exports.GetUnreadRegistrationApplicationCount = exports.RegistrationApplicationResponse = exports.ApproveRegistrationApplication = exports.ListRegistrationApplicationsResponse = exports.ListRegistrationApplications = exports.PurgeItemResponse = exports.PurgeComment = exports.PurgePost = exports.PurgeCommunity = exports.PurgePerson = exports.ResolveObjectResponse = exports.ResolveObject = exports.FederatedInstances = exports.LeaveAdmin = exports.MyUserInfo = exports.GetSiteResponse = exports.SiteResponse = exports.GetSite = exports.EditSite = exports.CreateSite = exports.GetModlogResponse = exports.GetModlog = exports.SearchResponse = exports.Search = void 0;
var class_transformer_1 = require("class-transformer");
require("reflect-metadata");
var utils_1 = require("../../utils");
var views_1 = require("../views");
/**
 * Search lemmy for different types of data.
 */
var Search = /** @class */ (function () {
    function Search(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], Search.prototype, "type_", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], Search.prototype, "community_id", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], Search.prototype, "community_name", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], Search.prototype, "creator_id", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], Search.prototype, "sort", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], Search.prototype, "listing_type", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], Search.prototype, "page", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], Search.prototype, "limit", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], Search.prototype, "auth", void 0);
    return Search;
}());
exports.Search = Search;
var SearchResponse = /** @class */ (function () {
    function SearchResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.CommentView; })
    ], SearchResponse.prototype, "comments", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.PostView; })
    ], SearchResponse.prototype, "posts", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.CommunityView; })
    ], SearchResponse.prototype, "communities", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.PersonViewSafe; })
    ], SearchResponse.prototype, "users", void 0);
    return SearchResponse;
}());
exports.SearchResponse = SearchResponse;
var GetModlog = /** @class */ (function () {
    function GetModlog(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetModlog.prototype, "mod_person_id", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetModlog.prototype, "community_id", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetModlog.prototype, "page", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetModlog.prototype, "limit", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetModlog.prototype, "auth", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetModlog.prototype, "other_person_id", void 0);
    return GetModlog;
}());
exports.GetModlog = GetModlog;
var GetModlogResponse = /** @class */ (function () {
    function GetModlogResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.ModRemovePostView; })
    ], GetModlogResponse.prototype, "removed_posts", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.ModLockPostView; })
    ], GetModlogResponse.prototype, "locked_posts", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.ModStickyPostView; })
    ], GetModlogResponse.prototype, "stickied_posts", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.ModRemoveCommentView; })
    ], GetModlogResponse.prototype, "removed_comments", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.ModRemoveCommunityView; })
    ], GetModlogResponse.prototype, "removed_communities", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.ModBanFromCommunityView; })
    ], GetModlogResponse.prototype, "banned_from_community", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.ModBanView; })
    ], GetModlogResponse.prototype, "banned", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.ModAddCommunityView; })
    ], GetModlogResponse.prototype, "added_to_community", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.ModTransferCommunityView; })
    ], GetModlogResponse.prototype, "transferred_to_community", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.ModAddView; })
    ], GetModlogResponse.prototype, "added", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.AdminPurgePersonView; })
    ], GetModlogResponse.prototype, "admin_purged_persons", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.AdminPurgeCommunityView; })
    ], GetModlogResponse.prototype, "admin_purged_communities", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.AdminPurgePostView; })
    ], GetModlogResponse.prototype, "admin_purged_posts", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.AdminPurgeCommentView; })
    ], GetModlogResponse.prototype, "admin_purged_comments", void 0);
    return GetModlogResponse;
}());
exports.GetModlogResponse = GetModlogResponse;
var CreateSite = /** @class */ (function () {
    function CreateSite(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreateSite.prototype, "sidebar", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreateSite.prototype, "description", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreateSite.prototype, "icon", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreateSite.prototype, "banner", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreateSite.prototype, "enable_downvotes", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreateSite.prototype, "open_registration", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreateSite.prototype, "enable_nsfw", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreateSite.prototype, "community_creation_admin_only", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreateSite.prototype, "require_email_verification", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreateSite.prototype, "require_application", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreateSite.prototype, "application_question", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreateSite.prototype, "private_instance", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreateSite.prototype, "default_theme", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreateSite.prototype, "default_post_listing_type", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CreateSite.prototype, "hide_modlog_mod_names", void 0);
    return CreateSite;
}());
exports.CreateSite = CreateSite;
var EditSite = /** @class */ (function () {
    function EditSite(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditSite.prototype, "name", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditSite.prototype, "sidebar", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditSite.prototype, "description", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditSite.prototype, "icon", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditSite.prototype, "banner", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditSite.prototype, "enable_downvotes", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditSite.prototype, "open_registration", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditSite.prototype, "enable_nsfw", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditSite.prototype, "community_creation_admin_only", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditSite.prototype, "require_email_verification", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditSite.prototype, "require_application", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditSite.prototype, "application_question", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditSite.prototype, "private_instance", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditSite.prototype, "default_theme", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditSite.prototype, "legal_information", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditSite.prototype, "default_post_listing_type", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], EditSite.prototype, "hide_modlog_mod_names", void 0);
    return EditSite;
}());
exports.EditSite = EditSite;
var GetSite = /** @class */ (function () {
    function GetSite(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], GetSite.prototype, "auth", void 0);
    return GetSite;
}());
exports.GetSite = GetSite;
var SiteResponse = /** @class */ (function () {
    function SiteResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.SiteView; })
    ], SiteResponse.prototype, "site_view", void 0);
    return SiteResponse;
}());
exports.SiteResponse = SiteResponse;
var GetSiteResponse = /** @class */ (function () {
    function GetSiteResponse() {
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return views_1.SiteView; })
    ], GetSiteResponse.prototype, "site_view", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.PersonViewSafe; })
    ], GetSiteResponse.prototype, "admins", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return MyUserInfo; })
    ], GetSiteResponse.prototype, "my_user", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return FederatedInstances; })
    ], GetSiteResponse.prototype, "federated_instances", void 0);
    return GetSiteResponse;
}());
exports.GetSiteResponse = GetSiteResponse;
/**
 * Your user info, such as blocks, follows, etc.
 */
var MyUserInfo = /** @class */ (function () {
    function MyUserInfo() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.LocalUserSettingsView; })
    ], MyUserInfo.prototype, "local_user_view", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.CommunityFollowerView; })
    ], MyUserInfo.prototype, "follows", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.CommunityModeratorView; })
    ], MyUserInfo.prototype, "moderates", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.CommunityBlockView; })
    ], MyUserInfo.prototype, "community_blocks", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.PersonBlockView; })
    ], MyUserInfo.prototype, "person_blocks", void 0);
    return MyUserInfo;
}());
exports.MyUserInfo = MyUserInfo;
var LeaveAdmin = /** @class */ (function () {
    function LeaveAdmin(init) {
        Object.assign(this, init);
    }
    return LeaveAdmin;
}());
exports.LeaveAdmin = LeaveAdmin;
var FederatedInstances = /** @class */ (function () {
    function FederatedInstances(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], FederatedInstances.prototype, "allowed", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], FederatedInstances.prototype, "blocked", void 0);
    return FederatedInstances;
}());
exports.FederatedInstances = FederatedInstances;
var ResolveObject = /** @class */ (function () {
    function ResolveObject(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], ResolveObject.prototype, "auth", void 0);
    return ResolveObject;
}());
exports.ResolveObject = ResolveObject;
var ResolveObjectResponse = /** @class */ (function () {
    function ResolveObjectResponse() {
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return views_1.CommentView; })
    ], ResolveObjectResponse.prototype, "comment", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return views_1.PostView; })
    ], ResolveObjectResponse.prototype, "post", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return views_1.CommunityView; })
    ], ResolveObjectResponse.prototype, "community", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return views_1.PersonViewSafe; })
    ], ResolveObjectResponse.prototype, "person", void 0);
    return ResolveObjectResponse;
}());
exports.ResolveObjectResponse = ResolveObjectResponse;
var PurgePerson = /** @class */ (function () {
    function PurgePerson(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], PurgePerson.prototype, "reason", void 0);
    return PurgePerson;
}());
exports.PurgePerson = PurgePerson;
var PurgeCommunity = /** @class */ (function () {
    function PurgeCommunity(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], PurgeCommunity.prototype, "reason", void 0);
    return PurgeCommunity;
}());
exports.PurgeCommunity = PurgeCommunity;
var PurgePost = /** @class */ (function () {
    function PurgePost(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], PurgePost.prototype, "reason", void 0);
    return PurgePost;
}());
exports.PurgePost = PurgePost;
var PurgeComment = /** @class */ (function () {
    function PurgeComment(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], PurgeComment.prototype, "reason", void 0);
    return PurgeComment;
}());
exports.PurgeComment = PurgeComment;
var PurgeItemResponse = /** @class */ (function () {
    function PurgeItemResponse() {
    }
    return PurgeItemResponse;
}());
exports.PurgeItemResponse = PurgeItemResponse;
var ListRegistrationApplications = /** @class */ (function () {
    function ListRegistrationApplications(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], ListRegistrationApplications.prototype, "unread_only", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], ListRegistrationApplications.prototype, "page", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], ListRegistrationApplications.prototype, "limit", void 0);
    return ListRegistrationApplications;
}());
exports.ListRegistrationApplications = ListRegistrationApplications;
var ListRegistrationApplicationsResponse = /** @class */ (function () {
    function ListRegistrationApplicationsResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.RegistrationApplicationView; })
    ], ListRegistrationApplicationsResponse.prototype, "registration_applications", void 0);
    return ListRegistrationApplicationsResponse;
}());
exports.ListRegistrationApplicationsResponse = ListRegistrationApplicationsResponse;
var ApproveRegistrationApplication = /** @class */ (function () {
    function ApproveRegistrationApplication(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], ApproveRegistrationApplication.prototype, "deny_reason", void 0);
    return ApproveRegistrationApplication;
}());
exports.ApproveRegistrationApplication = ApproveRegistrationApplication;
var RegistrationApplicationResponse = /** @class */ (function () {
    function RegistrationApplicationResponse() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return views_1.RegistrationApplicationView; })
    ], RegistrationApplicationResponse.prototype, "registration_application", void 0);
    return RegistrationApplicationResponse;
}());
exports.RegistrationApplicationResponse = RegistrationApplicationResponse;
var GetUnreadRegistrationApplicationCount = /** @class */ (function () {
    function GetUnreadRegistrationApplicationCount(init) {
        Object.assign(this, init);
    }
    return GetUnreadRegistrationApplicationCount;
}());
exports.GetUnreadRegistrationApplicationCount = GetUnreadRegistrationApplicationCount;
var GetUnreadRegistrationApplicationCountResponse = /** @class */ (function () {
    function GetUnreadRegistrationApplicationCountResponse() {
    }
    return GetUnreadRegistrationApplicationCountResponse;
}());
exports.GetUnreadRegistrationApplicationCountResponse = GetUnreadRegistrationApplicationCountResponse;
