import { Option } from "@sniptt/monads";
/**
 * Converts an option to an undefined. Necessary for API requests.
 */
export declare function toUndefined<T>(opt: Option<T>): T;
/**
 * Converts a null value to an option.
 */
export declare function toOption<T>(val: T): Option<T>;
