"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toOption = exports.toUndefined = void 0;
var monads_1 = require("@sniptt/monads");
/**
 * Converts an option to an undefined. Necessary for API requests.
 */
function toUndefined(opt) {
    return opt.isSome() ? opt.unwrap() : undefined;
}
exports.toUndefined = toUndefined;
/**
 * Converts a null value to an option.
 */
function toOption(val) {
    return (0, monads_1.Some)(val || undefined);
}
exports.toOption = toOption;
